=== debian/changelog ===
bpftrace (0.23.5-1) unstable; urgency=medium

  * New upstream release.
  * d/control: build-depends on libsframe-dev. Closes: #1110820.

 -- Vincent Bernat <bernat@debian.org>  Thu, 14 Aug 2025 08:34:25 +0200
