=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v(\d\S*)\.tar\.gz/bpftrace-$1\.tar\.gz/ \
  https://github.com/iovisor/bpftrace/tags .*/v(\d\S*)\.tar\.gz
